﻿-- Author      : Nerino1
-- Create Date : 12/1/2014
-- Version 1.7

local addonTitle
local _, _, difficultyID = GetInstanceInfo()
local _, _, difficultyID = GetInstanceInfo()

BossInfo_Version = "1.7";

function BossInfo_Loaded()
	DEFAULT_CHAT_FRAME:AddMessage("BossInfo Loaded.");
end

-- Slash Command Main

SLASH_BOSSINFO1, SLASH_BOSSINFO2 = '/bi', '/bossinfo';
function SlashCmdList.BOSSINFO(msg, editbox)
	if BossInfoFrame:IsShown() then
		BossInfoFrame:Hide()
		--DefaultFontStrings()
	else
		BossInfoFrame:Show()
	end
end

-- Enable Button Drag

function BossInfoButton_OnLoad(button)
	button:RegisterForDrag("LeftButton")
end

--Left Click Button

function BossInfoButton_OnClick(self, button)
	if button == "LeftButton" then
		if BossInfoFrame:IsShown() then
			BossInfoFrame:Hide()
		else
			BossInfoFrame:Show()
		end
	end
end

-- About Button

function About_OnClick()
	AboutFontStrings()
end

-- Close Button

function Close_OnClick()
	--DefaultFontStrings()
	BossInfoFrame:Hide()
end

-- Next Button

function Next_OnClick()
	Target1_OnClick()
end

--Default Text

function DefaultFontStrings()
	FontString1:SetText(dataTable[3])
	FontString2:SetText(dataTable[4])
	FontString3:SetText(dataTable[5])
	FontString8:SetText(dataTable[1])
	FontString9:SetText(dataTable[2])
end

function AboutFontStrings()
	FontString1:SetText(dataTable[6])
	FontString2:SetText(dataTable[7])
	FontString3:SetText(dataTable[8])
	FontString8:SetText(dataTable[1])
	FontString9:SetText(dataTable[9])
end

-- About Button Info

function bossinfoabout()
	FontString1:SetText(dataTable[10])
	FontString2:SetText(dataTable[11])
	FontString3:SetText(dataTable[12])
	FontString8:SetText(dataTable[1])
	FontString9:SetText(dataTable[2])
end

-- Target Button Info

function targetinfo()
	FontString1:SetText(dataTable[13])
	FontString2:SetText(dataTable[14])
	FontString3:SetText(dataTable[0])
	FontString8:SetText(dataTable[1])
	FontString9:SetText(dataTable[2])
end

function nextinfo()
	FontString1:SetText(dataTable[794])
	FontString2:SetText(dataTable[795])
	FontString3:SetText(dataTable[0])
	FontString8:SetText(dataTable[1])
	FontString9:SetText(dataTable[2])
end

-- Click Instance Button

function Instance_OnClick()
		ToggleDropDownMenu(1, nil, BossInfoMenu, Instance, 0, 0);
end

--Boss Info Menu

local BossInfoMenu = CreateFrame("Frame", "BossInfoMenu")
BossInfoMenu:SetPoint("CENTER", 19, -20) 
BossInfoMenu.displayMode = "MENU"
BossInfoMenu.info = {}
BossInfoMenu.UncheckHack = function(dropdownbutton)
    _G[dropdownbutton:GetName().."Check"]:Hide()
end
BossInfoMenu.HideMenu = function()
    if UIDROPDOWNMENU_OPEN_MENU == BossInfoMenu then
        CloseDropDownMenus()
    end
end


-- Main Menu

BossInfoMenu.initialize = function(self, level)
    if not level then return end
    local info = self.info
    wipe(info)
	if level == 1 then
		info.isTitle = 1
		info.text = "Select Expansion"
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		info.keepShownOnClick = 1
        info.disabled = nil
        info.isTitle = nil
        info.notCheckable = 1
		
		info.text = "Wrath of the Lich King"
        info.func = self.UncheckHack
        info.hasArrow = 1
        info.value = "lichsubmenu"
        UIDropDownMenu_AddButton(info, level)
		
		info.text = "Cataclysm"
        info.value = "catasubmenu"
        UIDropDownMenu_AddButton(info, level)
		
		info.text = "Mysts of Pandaria"
        info.value = "mystsubmenu"
        UIDropDownMenu_AddButton(info, level)
		
		info.text = "Warlords of Draenor"
        info.value = "wodsubmenu"
        UIDropDownMenu_AddButton(info, level)
		
		-- Close menu item
        info.hasArrow     = nil
        info.value        = nil
        info.notCheckable = 1
        info.text         = CLOSE
        info.func         = self.HideMenu
        UIDropDownMenu_AddButton(info, level)
	
	elseif level == 2 then
		if UIDROPDOWNMENU_MENU_VALUE == "lichsubmenu" then
			info.text = "Ahnkahet: The Old Kingdom"
			info.func = self.UncheckHack
			info.hasArrow = 1
			info.value = "submenu1"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Azjol-Nerub"
			info.value = "submenu2"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Culling of Stratholme"
			info.value = "submenu3"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Drak'Tharon Keep"
			info.value = "submenu4"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Forge of Souls"
			info.value = "submenu5"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Gundrak"
			info.value = "submenu6"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Halls of Lightning"
			info.value = "submenu7"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Halls of Reflection"
			info.value = "submenu8"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Halls of Stone"
			info.value = "submenu9"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Nexus"
			info.value = "submenu10"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Oculus"
			info.value = "submenu11"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Pit of Saron"
			info.value = "submenu12"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Trial of the Champion"
			info.value = "submenu13"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Utgarde Keep"
			info.value = "submenu14"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Utgarde Pinnacle"
			info.value = "submenu15"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Violet Hold"
			info.value = "submenu16"
			UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "catasubmenu" then
		
			info.text = "Blackrock Caverns"
			info.func = self.UncheckHack
			info.hasArrow = 1
			info.value = "catsubmenu1"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Deadmines"
			info.value = "catsubmenu2"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Grim Batol"
			info.value = "catsubmenu4"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Halls of Origination"
			info.value = "catsubmenu5"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Lost City of the Tol'vir"
			info.value = "catsubmenu6"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Shadowfang Keep"
			info.value = "catsubmenu7"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Stonecore"
			info.value = "catsubmenu8"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Throne of the Tides"
			info.value = "catsubmenu9"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Vortex Pinnacle"
			info.value = "catsubmenu10"
			UIDropDownMenu_AddButton(info, level)
			
--Placeholders	Mysts
		
		elseif UIDROPDOWNMENU_MENU_VALUE == "mystsubmenu" then
			info.text = "Explanation"
			info.func = self.UncheckHack
			info.hasArrow = 0
			info.func = mopinfo
			UIDropDownMenu_AddButton(info, level)


			
-- Warlords of Draenor
		
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu" then
			info.text = "Bloodmaul Slag Mine"
			info.func = self.UncheckHack
			info.hasArrow = 1
			info.value = "wodsubmenu1"
			UIDropDownMenu_AddButton(info, level)

			info.text = "Iron Docks"
			info.value = "wodsubmenu2"
			UIDropDownMenu_AddButton(info, level)	
			
			info.text = "Skyreach"
			info.value = "wodsubmenu3"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Auchindoun"
			info.value = "wodsubmenu4"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Grimrail Depot"
			info.value = "wodsubmenu5"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Shadowmoon Burial Grounds"
			info.value = "wodsubmenu6"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Everbloom"
			info.value = "wodsubmenu7"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Upper Blackrock Spire"
			info.value = "wodsubmenu8"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Highmaul"
			info.value = "wodsubmenu9"
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Blackrock Foundry"
			info.value = "wodsubmenu10"
			UIDropDownMenu_AddButton(info, level)
		end
	elseif level == 3 then
		if UIDROPDOWNMENU_MENU_VALUE == "submenu1" then
            info.text = "Elder Nadox"
			info.func = eldernadox
            UIDropDownMenu_AddButton(info, level)

            info.text = "Prince Taldaram"
			info.func = princetaldaram
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Jedoga Shadowseeker"
			info.func = jedogashadowseeker
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Herald Volazi"
			info.func = heraldvolazi
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Amanitar (Heroic)"
			info.func = amanitar
            UIDropDownMenu_AddButton(info, level)

        elseif UIDROPDOWNMENU_MENU_VALUE == "submenu2" then
            info.text = "Krik'thir the Gatewatcher"
			info.func = krikthirthegatewatcher			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Hadronox"
			info.func = hadronox			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Anub'arak"
			info.func = anubarak			
            UIDropDownMenu_AddButton(info, level)

		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu3" then
            info.text = "Meathook"
			info.func = meathook			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Salramm the Fleshcrafter"
			info.func = salrammthefleshcrafter			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Chrono-Lord Epoch"
			info.func = chronolordepoch			
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Mal'Ganis"
			info.func = malganis			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Infinite Corruptor (Heroic)"
			info.func = infinitecorruptor			
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu4" then
            info.text = "Trollgore"
			info.func = trollgore			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Novos the Summoner"
			info.func = novosthesummoner			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "King Dred"
			info.func = kingdred			
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Prophet Tharon'ja"
			info.func = theprophettharonja
			UIDropDownMenu_AddButton(info, level)

		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu5" then
            info.text = "Bronjahn"
			info.func = bronjahn			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Devourer of Souls"
			info.func = devourerofsouls
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu6" then
            info.text = "Slad'ran"
			info.func = sladran			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Drakkari Colossus"
			info.func = drakkaricolossus			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Moorabi"
			info.func = moorabi			
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Gal'darah"
			info.func = galdarah
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Eck the Ferocious (Heroic)"
			info.func = ecktheferocious			
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu7" then
            info.text = "General Bjarngrim"
			info.func = generalbjarngrim			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Volkhan"
			info.func = volkhan			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Ionar"
			info.func = ionar			
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Loken"
			info.func = loken
            UIDropDownMenu_AddButton(info, level)

		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu8" then
            info.text = "Falric"
			info.func = falric			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Marwyn"
			info.func = marwyn			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "The Lich King"
			info.func = thelichking
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu9" then
            info.text = "Maiden of Grief"
			info.func = maidenofgrief			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Krystallus"
			info.func = krystallus	
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Tribunal Chest"
			info.func = tribunalchest
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Sjonnir The Ironshaper"
			info.func = sjonnirtheironshaper
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu10" then
            info.text = "Grand Magus Telestra"
			info.func = grandmagustelestra			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Anomalus"
			info.func = anomalus			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Ormorok the Tree-Shaper"
			info.func = ormorokthetreeshaper
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Keristrasza"
			info.func = keristrasza
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Commander Stoutbeard / Commander Kolurg (Heroic)"
			info.func = commanderstoutbeardkolurg
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu11" then
            info.text = "Drakos the Interrogator"
			info.func = drakostheinterrogator			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Varos Cloudstrider"
			info.func = varoscloudstrider			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Mage-Lord Urom"
			info.func = magelordurom
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ley-Guardian Eregos"
			info.func = leyguardianeregos
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu12" then
            info.text = "Forgemaster Garfrost"
			info.func = forgemastergarfrost
            UIDropDownMenu_AddButton(info, level)

            info.text = "Ick & Krick"
			info.func = ickkrick			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Scourgelord Tyrannus"
			info.func = scourgelordtyrannus
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu13" then
            info.text = "Grand Champions"
			info.func = grandchampions			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Eadric the Pure"
			info.func = eadricthepure			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Argent Confessor Paletress"
			info.func = argentconfessorpaletress
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Black Knight"
			info.func = theblackknight
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu14" then
            info.text = "Prince Keleseth"
			info.func = princekeleseth			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Skarvald the Constructor / Dalronn the Controller"
			info.func = skarvalddalronn			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Ingvar the Plunderer"
			info.func = ingvartheplunderer
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu15" then
            info.text = "Svala Sorrowgrave"
			info.func = svalasorrowgrave
            UIDropDownMenu_AddButton(info, level)

            info.text = "Gortok Palehoof"
			info.func = gortokpalehoof			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Skadi the Ruthless"
			info.func = skaditheruthless
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "King Ymiron"
			info.func = kingymiron
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu16" then
            info.text = "Erekem"
			info.func = erekem
            UIDropDownMenu_AddButton(info, level)

            info.text = "Moragg"
			info.func = moragg
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Ichoron"
			info.func = ichoron
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Xevozz"
			info.func = xevozz
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lavanthor"
			info.func = lavanthor
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Zuramat the Obliterator"
			info.func = zuramattheobliterator
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Cyanigosa"
			info.func = cyanigosa
            UIDropDownMenu_AddButton(info, level)
		
		elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu1" then
            info.text = "Rom'ogg Bonecrusher"
			info.func = romoggbonecrusher
            UIDropDownMenu_AddButton(info, level)

            info.text = "Corla, Herald of Twilight"
			info.func = corlaheraldoftwilight
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Karsh Steelbender"
			info.func = karshsteelbender
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Beauty"
			info.func = beauty
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Ascendant Lord Obsidius"
			info.func = ascendantlordobsidius
            UIDropDownMenu_AddButton(info, level)

        elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu2" then
            info.text = "Glubtok"
			info.func = glubtok
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Helix Gearbreaker"
			info.func = helixgearbreaker			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Foe Reaper 5000"
			info.func = foereaper5000			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Admiral Ripsnarl"
			info.func = admiralripsnarl
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Captain Cookie"
			info.func = captaincookie
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Vanessa VanCleef (Heroic)"
			info.func = vanessavancleef		
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu4" then
            info.text = "General Umbriss"
			info.func = generalumbriss			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Forgemaster Throngus"
			info.func = forgemasterthrongus			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Drahga Shadowburner"
			info.func = drahgashadowburner			
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Erudax"
			info.func = erudax
			UIDropDownMenu_AddButton(info, level)

		elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu5" then
            info.text = "Temple Guardian Anhuur"
			info.func = templeguardiananhuur			
            UIDropDownMenu_AddButton(info, level)

            info.text = "Earthrager Ptah"
			info.func = earthragerptah
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Anraphet"
			info.func = anraphet
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Isiset"
			info.func = isiset
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Ammunae"
			info.func = ammunae
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Setesh"
			info.func = setesh
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Rajh"
			info.func = rajh
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu6" then
            info.text = "General Husam"
			info.func = generalhusam			
            UIDropDownMenu_AddButton(info, level)

            info.text = "High Prophet Barim"
			info.func = highprophetbarim			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Lockmaw & Augh"
			info.func = lockmawaugh	
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Siamat"
			info.func = siamat
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu7" then

            info.text = "Baron Ashbury"
			info.func = baronashbury
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Baron Silverlaine"
			info.func = baronsilverlaine
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Commander Springvale"
			info.func = commanderspringvale
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Lord Walden"
			info.func = lordwalden
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lord Godfrey"
			info.func = lordgodfrey
            UIDropDownMenu_AddButton(info, level)

		elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu8" then
            info.text = "Corborus"
			info.func = corborus
            UIDropDownMenu_AddButton(info, level)

            info.text = "Slabhide"
			info.func = slabhide		
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Ozruk"
			info.func = ozruk
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "High Priestess Azil"
			info.func = highpriestessazil
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu9" then
            info.text = "Lady Naz'jar"
			info.func = ladynazjar		
            UIDropDownMenu_AddButton(info, level)

            info.text = "Commander Ulthok"
			info.func = commanderulthok	
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Erunak Stonespeaker & Mindbender Ghur'sha"
			info.func = stonespeakerghursha
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozumat"
			info.func = ozumat
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "catsubmenu10" then
            info.text = "Grand Vizier Ertan"
			info.func = grandvizierertan		
            UIDropDownMenu_AddButton(info, level)

            info.text = "Altairus"
			info.func = altairus			
            UIDropDownMenu_AddButton(info, level)
			
            info.text = "Asaad"
			info.func = asaad
            UIDropDownMenu_AddButton(info, level)
		--Placeholders Mysts
		elseif UIDROPDOWNMENU_MENU_VALUE == "mystsubmenu1" then
			info.text = "Information"
			info.func = mopinfo
            UIDropDownMenu_AddButton(info, level)
					
		--Placeholders WOD
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu1" then
            
            info.text = "Slave Watcher Crushto"
			info.func = slavewatchercrushto		
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Magmolatus"
			info.func = magmolatus
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Roltall"
			info.func = roltall			
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Gug'rokk"
			info.func = gugrokk			
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu2" then
			info.text = "Fleshrender Nok'gar"
			info.func = fleshrendernokgar
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Grimrail Enforcers"
			info.func = grimrailenforcers
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Oshir"
			info.func = oshir
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Skulloc"
			info.func = skulloc
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu3" then
			info.text = "Ranjit"
			info.func = ranjit
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Araknath"
			info.func = araknath
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Rukhran"
			info.func = rukhran
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Sage Viryx"
			info.func = highsageviryx
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu4" then
			info.text = "Vigilant Kaathar"
			info.func = vigilantkaathar
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Soulbinder Nyami"
			info.func = soulbindernyami
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Azzakel"
			info.func = azzakel
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Teron'gor"
			info.func = terongor
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu5" then
		
			info.text = "Rocketspark and Borka"
			info.func = rocketsparkandborka
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Nitrogg Thundertower"
			info.func = nitroggthundertower
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Skylord Tovra"
			info.func = skylordtovra
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu6" then
			info.text = "Sadana Bloodfury"
			info.func = sadanabloodfury
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Nhallish"
			info.func = nhallish
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Bonemaw"
			info.func = bonemaw
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ner'zhul"
			info.func = nerzhul
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu7" then
			info.text = "Witherbark"
			info.func = witherbark
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ancient Protectors"
			info.func = ancientprotectors
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Xeri'tac"
			info.func = xeritac
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Archmage Sol"
			info.func = archmagesol
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Yalnu"
			info.func = yalnu
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu8" then
			info.text = "Orebender Gor'ashan"
			info.func = orebendergorashan
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Kyrak"
			info.func = kyrak
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Commander Tharbek"
			info.func = commandertharbek
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ragewing the Untamed"
			info.func = ragewingtheuntamed
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Warlord Zaela"
			info.func = warlordzaela
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu9" then
			info.text = "The Butcher"
			info.func = thebutcher
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Kargath Bladefist"
			info.func = kargathbladefist
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Twin Ogron"
			info.func = twinogron
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ko'ragh"
			info.func = koragh
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Tectus"
			info.func = tectus
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Brackenspore"
			info.func = brackenspore
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Imperator Mar'gok"
			info.func = imperatormargok
            UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "wodsubmenu10" then
			info.text = "Blackhand"
			info.func = blackhand
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Beastlord Darmac"
			info.func = beastlorddarmac
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Flamebender Ka'graz"
			info.func = flamebenderkagraz
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Operator Thogar"
			info.func = operatorthogar
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Blast Furnace"
			info.func = theblastfurnace
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Hans'gar and Franzok"
			info.func = hansgarandfranzok
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Gruul"
			info.func = gruul
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Kromog"
			info.func = kromog
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "Oregorger"
			info.func = oregorger
            UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Iron Maidens"
			info.func = theironmaidens
            UIDropDownMenu_AddButton(info, level)
		end
	end
end

function PrintAll(encounterID, difficultyID)
 EJ_SetDifficulty(difficultyID)
 local stack, encounter, _, _, curSectionID = {}, EJ_GetEncounterInfo(encounterID)
 -- print(encounter .. " abilities:")
 repeat
  local title, desc, depth, icon, model, siblingID, nextSectionID, filteredByDifficulty, link, _, f1, f2, f3, f4 = EJ_GetSectionInfo(curSectionID)
  if not filteredByDifficulty then
	msg = ""
	if title == "Tanks" then
			msg1 = link
			msg2 = desc
			msg3 = msg1 .. " |n |n " .. msg2
			msg4 = gsub(msg3, "$bullet;", "-")
   FontString1:SetText(msg4)
   end
   if title == "Damage Dealers" then
			msg1 = link
			msg2 = desc
			msg3 = msg1 .. " |n |n " .. msg2
			msg4 = gsub(msg3, "$bullet;", "-")
  FontString2:SetText(msg4)
   end
   if title == "Healers" then
			msg1 = link
			msg2 = desc
			msg3 = msg1 .. " |n |n " .. msg2
			msg4 = gsub(msg3, "$bullet;", "-")
   FontString3:SetText(msg4)
   end
  end
	table.insert(stack, siblingID)
	table.insert(stack, nextSectionID)
	curSectionID = table.remove(stack)
	until not curSectionID
end

function PrintAllParty(encounterID, difficultyID)
 EJ_SetDifficulty(difficultyID)
 
 SendChatMessage((dataTable[800]) ,IsInGroup(2) and "INSTANCE_CHAT" or IsInRaid() and "RAID" or IsInGroup(1) and "PARTY" or "SAY")
 local stack, encounter, _, _, curSectionID = {}, EJ_GetEncounterInfo(encounterID)
 -- print(encounter .. " abilities:")
 repeat
  local title, desc, depth, icon, model, siblingID, nextSectionID, filteredByDifficulty, link, _, f1, f2, f3, f4 = EJ_GetSectionInfo(curSectionID)
  if not filteredByDifficulty then
	msg = ""
	if title == "Tanks" then
			msg1 = link
   SendChatMessage((msg1) ,IsInGroup(2) and "INSTANCE_CHAT" or IsInRaid() and "RAID" or IsInGroup(1) and "PARTY" or "SAY")
   end
   if title == "Damage Dealers" then
			msg2 = link
   SendChatMessage((msg2) ,IsInGroup(2) and "INSTANCE_CHAT" or IsInRaid() and "RAID" or IsInGroup(1) and "PARTY" or "SAY")
   end
   if title == "Healers" then
			msg3 = link
   SendChatMessage((msg3) ,IsInGroup(2) and "INSTANCE_CHAT" or IsInRaid() and "RAID" or IsInGroup(1) and "PARTY" or "SAY")
   end
  end
	table.insert(stack, siblingID)
	table.insert(stack, nextSectionID)
	curSectionID = table.remove(stack)
	until not curSectionID
end
